#!/bin/bash
ver=1.1

###############################################
# Total Creds by Turranius for silicon^       #
#---------------------------------------------#
# Silly little script that will show the      #
# total amount of credits of all users        #
# combined and how much creds that calculates #
# to per user.                                #
#---------------------------------------------#
# Works from both glftpd and shell without    #
# having to change the paths.                 #
#                                             #
#-[Install]-----------------------------------#
# Copy the script to /glftpd/bin or something.#
# Make it executable.                         #
# Set up the paths in it, and add any users   #
# you which to exclude from it to the exclude #
# line. If you have folders in your users     #
# folder, add them here too and you wont get  #
# annoying errors.                            #
#                                             #
# Set excludeleech to false if you wish to    #
# include users with leech in the count. Not  #
# that I know why you would do that, but...   #
# Set excludedelled to false if you want to   #
# include users who have been delled, but not #
# purged yet.                                 #
#                                             #
# Set gbcount to false if you want the output #
# in MB instead. By default its GB            #
#                                             #
# Try running it from shell. If you want it   #
# as a custom command in glftpd as well, add  #
# site_cmd totalcreds EXEC /bin/totalcreds.sh #
# custom-totalcreds *                         #
# to glftpd.conf.                             #
#                                             #
#---------------------------------------------#
# Hint, crontab it and pipe the output to a   #
# file somewhere and you can have continuous  #
# statistics.                                 #
#---------------------------------------------#
# Contact turranius / turran on efnet.        #
# I usually hang out in #glftpd when          #
# Archimede isnt banning my poor ass :)       #
###############################################
# 1.1 : Add : Exclude delled users            #
# 1.0 : --- : Initial release.                #
###############################################
# Settings:

glroot=/glftpd
userfolder=/ftp-data/users
exclude='turranius|cruxis|disabled|backup|default.user'
excludeleech=true  # exclude leech users?
excludedelled=true # exclude delled users?
gbcount="true" # Output in GB? false=MB


###############################################
## go go go                                   #
###############################################

if [ "$FLAGS" = "" ]; then
  userfolder="$glroot$userfolder"
fi

total="0"
users="0"
go=yes

if [ "$gbcount" = "true" ]; then
  name="GB"
else
  name="MB"
fi

for user in `ls $userfolder | egrep -v $exclude`; do

  if [ "$excludeleech" = "true" ]; then
    leech="$( cat $userfolder/$user | grep -w RATIO | awk '{print $2}' )"
    if [ "$leech" = "0" ]; then
      go=no
    else
      go=yes
    fi
  fi

  if [ "$excludedelled" = "true" ]; then
    flags="$( cat $userfolder/$user | grep -w FLAGS | awk '{print $2}' )"
    checkflag=""
    checkflag="$( echo $flags | grep 6 )"
    if [ "$checkflag" != "" ]; then
      go=no
    else
      go=yes
    fi
  fi

  if [ "$go" = "yes" ]; then
    creds="$( cat $userfolder/$user | grep -w CREDITS | awk '{print $2}' )"
    if [ "$creds" != "" ]; then
      creds="$( expr $creds \/ 1024 )"
      users="$( expr $users \+ 1 )"
      if [ "$gbcount" = "true" ]; then
        creds="$( expr $creds \/ 1024 )"
      fi
      total="$( expr $total \+ $creds )"
    fi
  fi
done

average="$( expr $total \/ $users )"

echo "Total amount of credits: $total $name"
echo "That gives an average of $average $name per user ($users users)"

exit 0
